

StructuredBuffer<float3> points;

cbuffer cbSettings : register(b0)
{
	uint pointCount;
}

struct MyStruct
{
	float3 j;
	float3 k;
	float3 l;
};

RWStructuredBuffer<MyStruct> OutputBuffer : BACKBUFFER;

[numthreads(64,1,1)]
void CS(uint3 tid : SV_DispatchThreadID)
{
	

	
	if (tid.x >= pointCount)
		return;
	
	
	
	float3 p = points[tid.x+1];
	float3 q = points[tid.x];
	
	float3 a;
	float3 aCtrl;
	float3 b;
	float3 bCtrl;
	
	float3 m =  ( p - q ) * float3 (.5, .5, .5);
	m += q;
	
	a = q;
	b = p;
	aCtrl = float3 (m.x, a.y, m.z);
	bCtrl = float3 (m.x, b.y, m.z);
	
	
	if (tid.x % 4 == 0)
	{
		OutputBuffer[tid.x].j = 99999;
		OutputBuffer[tid.x].k = 99999;
		OutputBuffer[tid.x].l = a;	
		return;
	}
	
	
	OutputBuffer[tid.x].j = aCtrl;
	OutputBuffer[tid.x].k = bCtrl;
	OutputBuffer[tid.x].l = b;		
	

}

technique11 Apply
{
	pass P0
	{
		SetComputeShader( CompileShader( cs_5_0, CS() ) );
	}
}


